Crea o aggiorna una risorsa BackupVault appartenente a un gruppo di risorse.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataProtection/backupVaults/{vaultName}?api-version=2026-03-01
Parametri dell'URI
| Nome |
In |
Necessario |
Tipo |
Descrizione |
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
Nome del gruppo di risorse. Il nome è insensibile alle maiuscole e minuscole.
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
ID della sottoscrizione di destinazione. Il valore deve essere un UUID.
|
|
vaultName
|
path |
True
|
string
|
Nome di BackupVaultResource
|
|
api-version
|
query |
True
|
string
minLength: 1
|
Versione dell'API da usare per questa operazione.
|
| Nome |
Necessario |
Tipo |
Descrizione |
|
x-ms-authorization-auxiliary
|
|
string
|
|
|
x-ms-deleted-vault-id
|
|
string
|
L'ID dell'insieme di credenziali di backup eliminato da cui eseguire il ripristino durante il flusso di annullamento dell'eliminazione.
|
Corpo della richiesta
| Nome |
Necessario |
Tipo |
Descrizione |
|
location
|
True
|
string
|
Posizione geografica in cui risiede la risorsa
|
|
properties
|
True
|
BackupVault
|
Proprietà BackupVaultResource
|
|
eTag
|
|
string
|
ETag opzionale.
|
|
identity
|
|
DppIdentityDetails
|
Dettagli identità gestita di input
|
|
tags
|
|
object
|
Tag di risorsa.
|
Risposte
| Nome |
Tipo |
Descrizione |
|
200 OK
|
BackupVaultResource
|
L'operazione di aggiornamento della risorsa 'BackupVaultResource' è riuscita
|
|
201 Created
|
BackupVaultResource
|
Operazione di creazione della risorsa 'BackupVaultResource' riuscita
Intestazioni
- Location: string
- Retry-After: integer
|
|
Other Status Codes
|
CloudError
|
Risposta di errore imprevista.
|
Sicurezza
azure_auth
Azure Active Directory OAuth2 Flow.
Tipo:
oauth2
Flow:
implicit
URL di autorizzazione:
https://login.microsoftonline.com/common/oauth2/authorize
Ambiti
| Nome |
Descrizione |
|
user_impersonation
|
rappresentare l'account utente
|
Esempio
Create BackupVault
Esempio di richiesta
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
*/
/**
* Sample code: Create BackupVault.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void createBackupVault(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings().withSoftDeleteSettings(new SoftDeleteSettings()
.withState(SoftDeleteState.fromString("Enabled")).withRetentionDurationInDays(14.0D)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings().withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {"crossRegionRestoreSettings": {"state": "Enabled"}},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"}},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVault.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVault() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
FeatureSettings: &armdataprotection.FeatureSettings{
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelAdequate),
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
*/
async function createBackupVault() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
featureSettings: { crossRegionRestoreSettings: { state: "Enabled" } },
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: { softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" } },
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Risposta di esempio
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create BackupVault With CMK
Esempio di richiesta
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourceGroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned"
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
},
"softDeleteSettings": {
"retentionDurationInDays": 0,
"state": "Off"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CmkKekIdentity;
import com.azure.resourcemanager.dataprotection.models.CmkKeyVaultProperties;
import com.azure.resourcemanager.dataprotection.models.EncryptionSettings;
import com.azure.resourcemanager.dataprotection.models.EncryptionState;
import com.azure.resourcemanager.dataprotection.models.IdentityType;
import com.azure.resourcemanager.dataprotection.models.ImmutabilitySettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilityState;
import com.azure.resourcemanager.dataprotection.models.InfrastructureEncryptionState;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
*/
/**
* Sample code: Create BackupVault With CMK.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
createBackupVaultWithCMK(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings()
.withSoftDeleteSettings(
new SoftDeleteSettings().withState(SoftDeleteState.OFF).withRetentionDurationInDays(0.0D))
.withImmutabilitySettings(new ImmutabilitySettings().withState(ImmutabilityState.DISABLED))
.withEncryptionSettings(new EncryptionSettings().withState(EncryptionState.ENABLED)
.withKeyVaultProperties(new CmkKeyVaultProperties().withKeyUri("fakeTokenPlaceholder"))
.withKekIdentity(
new CmkKekIdentity().withIdentityType(IdentityType.USER_ASSIGNED).withIdentityId(
"/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"))
.withInfrastructureEncryption(InfrastructureEncryptionState.ENABLED)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_cmk.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned",
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled",
},
"immutabilitySettings": {"state": "Disabled"},
"softDeleteSettings": {"retentionDurationInDays": 0, "state": "Off"},
},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVaultWithCmk() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
EncryptionSettings: &armdataprotection.EncryptionSettings{
InfrastructureEncryption: to.Ptr(armdataprotection.InfrastructureEncryptionStateEnabled),
KekIdentity: &armdataprotection.CmkKekIdentity{
IdentityID: to.Ptr("/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"),
IdentityType: to.Ptr(armdataprotection.IdentityTypeUserAssigned),
},
KeyVaultProperties: &armdataprotection.CmkKeyVaultProperties{
KeyURI: to.Ptr("https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"),
},
State: to.Ptr(armdataprotection.EncryptionStateEnabled),
},
ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
},
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](0),
State: to.Ptr(armdataprotection.SoftDeleteStateOff),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
*/
async function createBackupVaultWithCMK() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: {
encryptionSettings: {
infrastructureEncryption: "Enabled",
kekIdentity: {
identityId:
"/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
identityType: "UserAssigned",
},
keyVaultProperties: {
keyUri: "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3",
},
state: "Enabled",
},
immutabilitySettings: { state: "Disabled" },
softDeleteSettings: { retentionDurationInDays: 0, state: "Off" },
},
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Risposta di esempio
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2023-04-01-privatepreview
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourceGroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned"
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
},
"softDeleteSettings": {
"retentionDurationInDays": 0,
"state": "Off"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create BackupVault With MSI
Esempio di richiesta
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
*/
/**
* Sample code: Create BackupVault With MSI.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
createBackupVaultWithMSI(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings().withSoftDeleteSettings(new SoftDeleteSettings()
.withState(SoftDeleteState.fromString("Enabled")).withRetentionDurationInDays(14.0D)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings().withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_msi.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {"crossRegionRestoreSettings": {"state": "Enabled"}},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"}},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVaultWithMsi() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
FeatureSettings: &armdataprotection.FeatureSettings{
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelAdequate),
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
*/
async function createBackupVaultWithMSI() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
featureSettings: { crossRegionRestoreSettings: { state: "Enabled" } },
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: { softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" } },
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Risposta di esempio
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create or Update Backup Vault With CMK and Resource Guard Enabled
Esempio di richiesta
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"identity": {
"type": "None"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"state": "Off",
"retentionDurationInDays": 0
},
"immutabilitySettings": {
"state": "Disabled"
},
"encryptionSettings": {
"state": "Enabled",
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"kekIdentity": {
"identityType": "UserAssigned",
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"
},
"infrastructureEncryption": "Enabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
Risposta di esempio
Retry-After: 10
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
{
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"location": "WestUS",
"tags": {
"key1": "val1"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"state": "Off",
"retentionDurationInDays": 0
},
"immutabilitySettings": {
"state": "Disabled"
},
"encryptionSettings": {
"state": "Enabled",
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"kekIdentity": {
"identityType": "UserAssigned",
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"
},
"infrastructureEncryption": "Enabled"
}
},
"resourceGuardOperationRequests": [
"/subscriptions/754ec39f-8d2a-44cf-bfbf-13107ac85c36/resourcegroups/mua-testing/providers/Microsoft.DataProtection/resourceGuards/gvjreddy-test-ecy-rg-reader/dppModifyEncryptionSettingsRequests/default"
],
"provisioningState": "Provisioning",
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
{
"identity": {
"type": "None"
},
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"location": "WestUS",
"tags": {
"key1": "val1"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
Restore a soft-deleted backup vault
Esempio di richiesta
PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
}
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.CrossSubscriptionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossSubscriptionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilitySettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilityState;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
*/
/**
* Sample code: Restore a soft-deleted backup vault.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
restoreASoftDeletedBackupVault(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings()
.withSoftDeleteSettings(new SoftDeleteSettings().withState(SoftDeleteState.fromString("Enabled"))
.withRetentionDurationInDays(14.0D))
.withImmutabilitySettings(new ImmutabilitySettings().withState(ImmutabilityState.DISABLED)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings()
.withCrossSubscriptionRestoreSettings(
new CrossSubscriptionRestoreSettings().withState(CrossSubscriptionRestoreState.DISABLED))
.withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder"))
.withXMsDeletedVaultId(
"/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample")
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_undelete.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {"state": "Enabled"},
"crossSubscriptionRestoreSettings": {"state": "Disabled"},
},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {
"immutabilitySettings": {"state": "Disabled"},
"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"},
},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/PutBackupVaultWithUndelete.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_restoreASoftDeletedBackupVault() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("00000000-0000-0000-0000-000000000000", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
},
},
FeatureSettings: &armdataprotection.FeatureSettings{
CrossSubscriptionRestoreSettings: &armdataprotection.CrossSubscriptionRestoreSettings{
State: to.Ptr(armdataprotection.CrossSubscriptionRestoreStateDisabled),
},
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, &armdataprotection.BackupVaultsClientBeginCreateOrUpdateOptions{
XMSDeletedVaultID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample")})
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Location: to.Ptr("WestUS"),
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample"),
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/BackupVaults"),
// Properties: &armdataprotection.BackupVault{
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// ResourceMoveState: to.Ptr(armdataprotection.ResourceMoveStateUnknown),
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
// State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// },
// },
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossSubscriptionRestoreSettings: &armdataprotection.CrossSubscriptionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossSubscriptionRestoreStateDisabled),
// },
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelMaximum),
// IsVaultProtectedByResourceGuard: to.Ptr(false),
// ResourceGuardOperationRequests: []*string{
// },
// ReplicatedRegions: []*string{
// },
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
*/
async function restoreASoftDeletedBackupVault() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-0000-0000-0000-000000000000";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate(
"SampleResourceGroup",
"swaggerExample",
{
location: "WestUS",
properties: {
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: {
softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" },
immutabilitySettings: { state: "Disabled" },
},
storageSettings: [{ datastoreType: "VaultStore", type: "LocallyRedundant" }],
featureSettings: {
crossSubscriptionRestoreSettings: { state: "Disabled" },
crossRegionRestoreSettings: { state: "Enabled" },
},
},
tags: { key1: "val1" },
},
{
xMsDeletedVaultId:
"/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample",
},
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Risposta di esempio
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/BackupVaults",
"properties": {
"provisioningState": "Succeeded",
"resourceMoveState": "Unknown",
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"secureScore": "Maximum",
"isVaultProtectedByResourceGuard": false,
"resourceGuardOperationRequests": [],
"replicatedRegions": []
}
}
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/BackupVaults",
"properties": {
"provisioningState": "Succeeded",
"resourceMoveState": "Unknown",
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"secureScore": "Maximum",
"isVaultProtectedByResourceGuard": false,
"resourceGuardOperationRequests": [],
"replicatedRegions": []
}
}
Definizioni
AlertsState
Enumerazione
| Valore |
Descrizione |
|
Enabled
|
|
|
Disabled
|
|
AzureMonitorAlertSettings
Oggetto
Impostazioni per gli avvisi basati su Monitoraggio di Azure
| Nome |
Tipo |
Descrizione |
|
alertsForAllJobFailures
|
AlertsState
|
|
BackupVault
Oggetto
Archivio di Backup
| Nome |
Tipo |
Descrizione |
|
bcdrSecurityLevel
|
BCDRSecurityLevel
|
Livello di sicurezza dell'insieme di credenziali di backup
|
|
featureSettings
|
FeatureSettings
|
Impostazioni funzionalità
|
|
isVaultProtectedByResourceGuard
|
boolean
|
Insieme di credenziali protetto da Resource Guard
|
|
monitoringSettings
|
MonitoringSettings
|
Impostazioni di monitoraggio
|
|
provisioningState
|
ProvisioningState
|
Stato di provisioning della risorsa BackupVault
|
|
replicatedRegions
|
string[]
|
Elenco di aree replicate per l'insieme di credenziali di backup
|
|
resourceGuardOperationRequests
|
string[]
|
ResourceGuardOperationRequests su cui verrà eseguito il controllo LAC
|
|
resourceMoveDetails
|
ResourceMoveDetails
|
Dettagli dello spostamento delle risorse per l'insieme di credenziali di backup
|
|
resourceMoveState
|
ResourceMoveState
|
Stato dello spostamento delle risorse per l'insieme di credenziali di backup
|
|
secureScore
|
SecureScoreLevel
|
Punteggio di sicurezza dell'insieme di credenziali di backup
|
|
securitySettings
|
SecuritySettings
|
Impostazioni di sicurezza
|
|
storageSettings
|
StorageSetting[]
|
Impostazioni di archiviazione
|
BackupVaultResource
Oggetto
Risorsa dell'insieme di credenziali di backup
| Nome |
Tipo |
Descrizione |
|
eTag
|
string
|
ETag opzionale.
|
|
id
|
string
(arm-id)
|
ID risorsa completo per la risorsa. Ad esempio, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
|
|
identity
|
DppIdentityDetails
|
Dettagli identità gestita di input
|
|
location
|
string
|
Posizione geografica in cui risiede la risorsa
|
|
name
|
string
|
Nome della risorsa
|
|
properties
|
BackupVault
|
Proprietà BackupVaultResource
|
|
systemData
|
systemData
|
Metadati di Azure Resource Manager contenenti le informazioni createdBy e modifiedBy.
|
|
tags
|
object
|
Tag di risorsa.
|
|
type
|
string
|
Tipo di risorsa. Ad esempio, "Microsoft.Compute/virtualMachines" o "Microsoft.Storage/storageAccounts"
|
BCDRSecurityLevel
Enumerazione
Livello di sicurezza dell'insieme di credenziali di backup
| Valore |
Descrizione |
|
Poor
|
|
|
Fair
|
|
|
Good
|
|
|
Excellent
|
|
|
NotSupported
|
|
CloudError
Oggetto
Risposta di errore da Backup di Azure.
| Nome |
Tipo |
Descrizione |
|
error
|
Error
|
Risposta di errore di gestione delle risorse.
|
CmkKekIdentity
Oggetto
Dettagli dell'identità gestita usata per la chiave gestita
| Nome |
Tipo |
Descrizione |
|
identityId
|
string
|
Identità gestita da usare che dispone delle autorizzazioni di accesso all'insieme di credenziali delle chiavi. Specificare un valore qui nel caso in cui i tipi di identità: solo 'UserAssigned'.
|
|
identityType
|
IdentityType
|
Tipo di identità. "SystemAssigned" e "UserAssigned" si escludono a vicenda. 'SystemAssigned' userà l'identità gestita creata in modo implicito.
|
CmkKeyVaultProperties
Oggetto
Proprietà dell'insieme di credenziali delle chiavi che ospita la chiave gestita dal cliente
| Nome |
Tipo |
Descrizione |
|
keyUri
|
string
|
URI della chiave gestita dal cliente
|
createdByType
Enumerazione
Tipo di identità che ha creato la risorsa.
| Valore |
Descrizione |
|
User
|
|
|
Application
|
|
|
ManagedIdentity
|
|
|
Key
|
|
CrossRegionRestoreSettings
Oggetto
CrossRegionRestoreState
Enumerazione
Stato CrossRegionRestore
| Valore |
Descrizione |
|
Disabled
|
|
|
Enabled
|
|
CrossSubscriptionRestoreSettings
Oggetto
Impostazioni crossSubscriptionRestore
CrossSubscriptionRestoreState
Enumerazione
Stato CrossSubscriptionRestore
| Valore |
Descrizione |
|
Disabled
|
|
|
PermanentlyDisabled
|
|
|
Enabled
|
|
DppIdentityDetails
Oggetto
Dettagli identità
| Nome |
Tipo |
Descrizione |
|
principalId
|
string
|
ID oggetto dell'oggetto entità servizio per l'identità gestita usata per concedere l'accesso in base al ruolo a una risorsa di Azure.
|
|
tenantId
|
string
|
Identificatore univoco globale (GUID) che rappresenta il tenant di Azure AD in cui la risorsa è ora membro.
|
|
type
|
string
|
IdentityType che può essere SystemAssigned, UserAssigned, 'SystemAssigned,UserAssigned' o Nessuno
|
|
userAssignedIdentities
|
<string,
UserAssignedIdentity>
|
Ottiene o imposta le identità assegnate dall'utente.
|
encryptionSettings
Oggetto
Dettagli della chiave gestita dal cliente della risorsa.
| Nome |
Tipo |
Descrizione |
|
infrastructureEncryption
|
InfrastructureEncryptionState
|
Abilitazione/disabilitazione dello stato di crittografia doppia
|
|
kekIdentity
|
CmkKekIdentity
|
Dettagli dell'identità gestita usata per la chiave gestita
|
|
keyVaultProperties
|
CmkKeyVaultProperties
|
Proprietà dell'insieme di credenziali delle chiavi che ospita la chiave gestita dal cliente
|
|
state
|
EncryptionState
|
Stato di crittografia dell'insieme di credenziali di backup.
|
EncryptionState
Enumerazione
Stato di crittografia dell'insieme di credenziali di backup.
| Valore |
Descrizione |
|
Enabled
|
La crittografia della chiave gestita dal cliente è abilitata nell'insieme di credenziali di backup
|
|
Disabled
|
La crittografia della chiave gestita dal cliente è disabilitata nell'insieme di credenziali di backup. L'utente non può impostare questo stato dopo che lo stato di crittografia è "Abilitato".
|
|
Inconsistent
|
La crittografia della chiave gestita dal cliente è incoerente nell'insieme di credenziali di backup. Questo stato indica che l'utente deve ripetere l'operazione delle impostazioni di crittografia immediatamente per correggere lo stato.
|
Error
Oggetto
Risposta di errore di gestione delle risorse.
| Nome |
Tipo |
Descrizione |
|
additionalInfo
|
ErrorAdditionalInfo[]
|
Informazioni aggiuntive sull'errore.
|
|
code
|
string
|
Codice di errore.
|
|
details
|
Error[]
|
Dettagli dell'errore.
|
|
message
|
string
|
Messaggio di errore.
|
|
target
|
string
|
Destinazione dell'errore.
|
ErrorAdditionalInfo
Oggetto
Informazioni aggiuntive sull'errore di gestione delle risorse.
| Nome |
Tipo |
Descrizione |
|
info
|
object
|
Informazioni aggiuntive.
|
|
type
|
string
|
Tipo di informazioni aggiuntive.
|
FeatureSettings
Oggetto
Classe contenente le impostazioni delle funzionalità dell'insieme di credenziali
IdentityType
Enumerazione
Tipo di identità. "SystemAssigned" e "UserAssigned" si escludono a vicenda. 'SystemAssigned' userà l'identità gestita creata in modo implicito.
| Valore |
Descrizione |
|
SystemAssigned
|
|
|
UserAssigned
|
|
ImmutabilitySettings
Oggetto
Impostazioni di immutabilità a livello di insieme di credenziali
ImmutabilityState
Enumerazione
Stato di immutabilità
| Valore |
Descrizione |
|
Disabled
|
|
|
Unlocked
|
|
|
Locked
|
|
InfrastructureEncryptionState
Enumerazione
Abilitazione/disabilitazione dello stato di crittografia doppia
| Valore |
Descrizione |
|
Enabled
|
|
|
Disabled
|
|
MonitoringSettings
Oggetto
Impostazioni di monitoraggio
| Nome |
Tipo |
Descrizione |
|
azureMonitorAlertSettings
|
AzureMonitorAlertSettings
|
Impostazioni per gli avvisi basati su Monitoraggio di Azure
|
ProvisioningState
Enumerazione
Stato di provisioning della risorsa BackupVault
| Valore |
Descrizione |
|
Failed
|
|
|
Provisioning
|
|
|
Succeeded
|
|
|
Unknown
|
|
|
Updating
|
|
ResourceMoveDetails
Oggetto
ResourceMoveDetails verrà restituito in risposta alla chiamata GetResource da ARM
| Nome |
Tipo |
Descrizione |
|
completionTimeUtc
|
string
|
Tempo di completamento nell'ora UTC dell'ultima operazione ResourceMove tentata. Formato ISO 8601.
|
|
operationId
|
string
|
CorrelationId dell'ultima operazione ResourceMove tentata
|
|
sourceResourcePath
|
string
|
Percorso risorsa arm della risorsa di origine
|
|
startTimeUtc
|
string
|
Ora di inizio nell'ora UTC dell'ultima operazione ResourceMove tentata. Formato ISO 8601.
|
|
targetResourcePath
|
string
|
Percorso della risorsa arm della risorsa di destinazione usata nell'operazione ResourceMove più recente
|
ResourceMoveState
Enumerazione
Stato dello spostamento delle risorse per l'insieme di credenziali di backup
| Valore |
Descrizione |
|
Unknown
|
|
|
InProgress
|
|
|
PrepareFailed
|
|
|
CommitFailed
|
|
|
Failed
|
|
|
PrepareTimedout
|
|
|
CommitTimedout
|
|
|
CriticalFailure
|
|
|
PartialSuccess
|
|
|
MoveSucceeded
|
|
SecureScoreLevel
Enumerazione
Punteggio di sicurezza dell'insieme di credenziali di backup
| Valore |
Descrizione |
|
None
|
|
|
Minimum
|
|
|
Adequate
|
|
|
Maximum
|
|
|
NotSupported
|
|
SecuritySettings
Oggetto
Classe contenente le impostazioni di sicurezza dell'insieme di credenziali
| Nome |
Tipo |
Descrizione |
|
encryptionSettings
|
encryptionSettings
|
Dettagli della chiave gestita dal cliente della risorsa.
|
|
immutabilitySettings
|
ImmutabilitySettings
|
Impostazioni di immutabilità a livello di insieme di credenziali
|
|
softDeleteSettings
|
SoftDeleteSettings
|
Impostazioni correlate all'eliminazione temporanea
|
SoftDeleteSettings
Oggetto
Impostazioni correlate all'eliminazione temporanea
| Nome |
Tipo |
Descrizione |
|
retentionDurationInDays
|
number
(double)
|
Durata conservazione eliminazione temporanea
|
|
state
|
SoftDeleteState
|
Stato dell'eliminazione temporanea
|
SoftDeleteState
Enumerazione
Stato dell'eliminazione temporanea
| Valore |
Descrizione |
|
Off
|
Eliminazione temporanea disattivata per BackupVault
|
|
On
|
L'eliminazione temporanea è abilitata per BackupVault, ma può essere disattivata
|
|
AlwaysOn
|
L'eliminazione temporanea è abilitata in modo permanente per BackupVault e l'impostazione non può essere modificata
|
StorageSetting
Oggetto
Impostazione di archiviazione
StorageSettingStoreTypes
Enumerazione
Ottiene o imposta il tipo dell'archivio dati.
| Valore |
Descrizione |
|
ArchiveStore
|
|
|
OperationalStore
|
|
|
VaultStore
|
|
StorageSettingTypes
Enumerazione
Ottiene o imposta il tipo.
| Valore |
Descrizione |
|
GeoRedundant
|
|
|
LocallyRedundant
|
|
|
ZoneRedundant
|
|
systemData
Oggetto
Metadati relativi alla creazione e all'ultima modifica della risorsa.
| Nome |
Tipo |
Descrizione |
|
createdAt
|
string
(date-time)
|
Timestamp della creazione della risorsa (UTC).
|
|
createdBy
|
string
|
Identità che ha creato la risorsa.
|
|
createdByType
|
createdByType
|
Tipo di identità che ha creato la risorsa.
|
|
lastModifiedAt
|
string
(date-time)
|
Timestamp dell'ultima modifica della risorsa (UTC)
|
|
lastModifiedBy
|
string
|
Identità che ha modificato l'ultima volta la risorsa.
|
|
lastModifiedByType
|
createdByType
|
Tipo di identità che ha modificato l'ultima volta la risorsa.
|
UserAssignedIdentity
Oggetto
Proprietà di identità assegnate dall'utente
| Nome |
Tipo |
Descrizione |
|
clientId
|
string
(uuid)
|
ID client dell'identità assegnata.
|
|
principalId
|
string
(uuid)
|
ID entità dell'identità assegnata.
|